//==================================================================
// DirScrnWrite.h									<tur xx-xx-92>
//
//	Protos, etc., for direct screen writing.
//
//==================================================================

#ifndef	__DirScrnWrite__
#define	__DirScrnWrite__

#ifndef	__RectUtils__
#include "RectUtils.h"
#endif

#ifndef __PALETTES__
#include "Palettes.h"
#endif

extern const Point		nullPt;
extern long				*ReplicatedByteLUT;		// ReplicatedByteLUT[2] = 0x02020202, etc
extern int				gPaletteColorsUsed;
extern CTabHandle		gDirClut;
extern PaletteHandle	gDirPalette;
extern GDHandle			gTheScreenDevice;

extern void BeginDirectScreenWrite(Rect *globalRect);
extern void EndDirectScreenWrite(void);

extern Boolean CanWriteDirectToScreen(WindowPtr win);
extern Boolean CheckDirScrnWriteFor(WindowPtr win);
extern void InitDirScrnWrite(void);


typedef void (*PixMungeFunc)(unsigned char *destPix, unsigned char *srcPix);

extern void DirCopyPix(long *srcPixels, unsigned long srcRB, int srcWid, int srcHt,
						int winStartX, int winStartY, PixMungeFunc munge);

extern void DirCopyPixScaled2(long *srcPixels, unsigned long srcRB, int srcWid, int srcHt,
						int winStartX, int winStartY, PixMungeFunc munge);

// handy for having a variable function pointer to one of the above...
typedef void (*PCopyPixFunc)(long *srcPixels, unsigned long srcRB, int srcWid, int srcHt,
						int winStartX, int winStartY, PixMungeFunc munge);

extern void NotMungeFunc(unsigned char *destPix, unsigned char *srcPix);	// NOT
extern void AndMungeFunc(unsigned char *destPix, unsigned char *srcPix);	// AND
																			// etc...

// A function to initialise the palette and return the #colors used.
typedef int (*InitPaletteFunc)(PaletteHandle ph);

extern void InitDirScrnGraphicsWindow(WindowPtr wp, InitPaletteFunc ipf);
extern void TermDirScrnGraphicsWindow(WindowPtr wp);

#endif	/* __DirScrnWrite__ */
